local internet = require("internet")
local event = require("event")
local os = require("os")
local fs = require("filesystem")
local component = require("component")

local db = require("libdata-bus")

local ms = component.motion_sensor 

db.setupValue("nearby_players", {type="timed_list", timeout=30})
 
local exceptions = {}
 
local function time_global()
 while true do
  local res, t = pcall(internet.request("http://www.timeapi.org/utc/in+three+hours?format=\\d/\\m/\\y%20\\I:\\M:\\S%20\\p"))
  if res then
   return t
  end
 end
end
 
--local function ret_false()
-- return false
--end
 
--event.shouldSoftInterrupt = ret_false
--event.shouldInterrupt = ret_false
 
if not fs.exists("/var") then
 fs.makeDirectory("/var")
end
if not fs.exists("/var/log") then
 fs.makeDirectory("/var/log")
end
if not fs.exists("/var/log/motion.log") then
 io.open("/var/log/motion.log", "w"):close()
end
 
local function motion_handler(n,a,b,k,p,player)
 if exceptions[player] ~= true then
  --print(player.." detected!")
  db.push("nearby_players", player)
 end
end

local function list_handler(e, n, v)
 if n == "nearby_players" then
  local f = io.open("/var/log/motion.log", "a")
  local time = time_global();
  f:write("["..time.."] ")
  if e == "data_list_add" then
   f:write("[FOUND]:")
  elseif e == "data_list_remove" then
   f:write("[LOST ]:")
  end
  f:write(v)
  f:close()
 end
end

event.listen("motion", motion_handler)
event.listen("data_list_remove", list_handler)
event.listen("data_list_add", list_handler)